// package: supervisor
// file: port.proto

import * as jspb from "google-protobuf";

export class TunnelPortRequest extends jspb.Message {
  getPort(): number;
  setPort(value: number): void;

  getTargetPort(): number;
  setTargetPort(value: number): void;

  getVisibility(): TunnelVisiblityMap[keyof TunnelVisiblityMap];
  setVisibility(value: TunnelVisiblityMap[keyof TunnelVisiblityMap]): void;

  getClientId(): string;
  setClientId(value: string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): TunnelPortRequest.AsObject;
  static toObject(includeInstance: boolean, msg: TunnelPortRequest): TunnelPortRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: TunnelPortRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): TunnelPortRequest;
  static deserializeBinaryFromReader(message: TunnelPortRequest, reader: jspb.BinaryReader): TunnelPortRequest;
}

export namespace TunnelPortRequest {
  export type AsObject = {
    port: number,
    targetPort: number,
    visibility: TunnelVisiblityMap[keyof TunnelVisiblityMap],
    clientId: string,
  }
}

export class TunnelPortResponse extends jspb.Message {
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): TunnelPortResponse.AsObject;
  static toObject(includeInstance: boolean, msg: TunnelPortResponse): TunnelPortResponse.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: TunnelPortResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): TunnelPortResponse;
  static deserializeBinaryFromReader(message: TunnelPortResponse, reader: jspb.BinaryReader): TunnelPortResponse;
}

export namespace TunnelPortResponse {
  export type AsObject = {
  }
}

export class CloseTunnelRequest extends jspb.Message {
  getPort(): number;
  setPort(value: number): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): CloseTunnelRequest.AsObject;
  static toObject(includeInstance: boolean, msg: CloseTunnelRequest): CloseTunnelRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: CloseTunnelRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): CloseTunnelRequest;
  static deserializeBinaryFromReader(message: CloseTunnelRequest, reader: jspb.BinaryReader): CloseTunnelRequest;
}

export namespace CloseTunnelRequest {
  export type AsObject = {
    port: number,
  }
}

export class CloseTunnelResponse extends jspb.Message {
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): CloseTunnelResponse.AsObject;
  static toObject(includeInstance: boolean, msg: CloseTunnelResponse): CloseTunnelResponse.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: CloseTunnelResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): CloseTunnelResponse;
  static deserializeBinaryFromReader(message: CloseTunnelResponse, reader: jspb.BinaryReader): CloseTunnelResponse;
}

export namespace CloseTunnelResponse {
  export type AsObject = {
  }
}

export class EstablishTunnelRequest extends jspb.Message {
  hasDesc(): boolean;
  clearDesc(): void;
  getDesc(): TunnelPortRequest | undefined;
  setDesc(value?: TunnelPortRequest): void;

  hasData(): boolean;
  clearData(): void;
  getData(): Uint8Array | string;
  getData_asU8(): Uint8Array;
  getData_asB64(): string;
  setData(value: Uint8Array | string): void;

  getOutputCase(): EstablishTunnelRequest.OutputCase;
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): EstablishTunnelRequest.AsObject;
  static toObject(includeInstance: boolean, msg: EstablishTunnelRequest): EstablishTunnelRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: EstablishTunnelRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): EstablishTunnelRequest;
  static deserializeBinaryFromReader(message: EstablishTunnelRequest, reader: jspb.BinaryReader): EstablishTunnelRequest;
}

export namespace EstablishTunnelRequest {
  export type AsObject = {
    desc?: TunnelPortRequest.AsObject,
    data: Uint8Array | string,
  }

  export enum OutputCase {
    OUTPUT_NOT_SET = 0,
    DESC = 1,
    DATA = 2,
  }
}

export class EstablishTunnelResponse extends jspb.Message {
  getData(): Uint8Array | string;
  getData_asU8(): Uint8Array;
  getData_asB64(): string;
  setData(value: Uint8Array | string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): EstablishTunnelResponse.AsObject;
  static toObject(includeInstance: boolean, msg: EstablishTunnelResponse): EstablishTunnelResponse.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: EstablishTunnelResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): EstablishTunnelResponse;
  static deserializeBinaryFromReader(message: EstablishTunnelResponse, reader: jspb.BinaryReader): EstablishTunnelResponse;
}

export namespace EstablishTunnelResponse {
  export type AsObject = {
    data: Uint8Array | string,
  }
}

export class AutoTunnelRequest extends jspb.Message {
  getEnabled(): boolean;
  setEnabled(value: boolean): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): AutoTunnelRequest.AsObject;
  static toObject(includeInstance: boolean, msg: AutoTunnelRequest): AutoTunnelRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: AutoTunnelRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): AutoTunnelRequest;
  static deserializeBinaryFromReader(message: AutoTunnelRequest, reader: jspb.BinaryReader): AutoTunnelRequest;
}

export namespace AutoTunnelRequest {
  export type AsObject = {
    enabled: boolean,
  }
}

export class AutoTunnelResponse extends jspb.Message {
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): AutoTunnelResponse.AsObject;
  static toObject(includeInstance: boolean, msg: AutoTunnelResponse): AutoTunnelResponse.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: AutoTunnelResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): AutoTunnelResponse;
  static deserializeBinaryFromReader(message: AutoTunnelResponse, reader: jspb.BinaryReader): AutoTunnelResponse;
}

export namespace AutoTunnelResponse {
  export type AsObject = {
  }
}

export class RetryAutoExposeRequest extends jspb.Message {
  getPort(): number;
  setPort(value: number): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): RetryAutoExposeRequest.AsObject;
  static toObject(includeInstance: boolean, msg: RetryAutoExposeRequest): RetryAutoExposeRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: RetryAutoExposeRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): RetryAutoExposeRequest;
  static deserializeBinaryFromReader(message: RetryAutoExposeRequest, reader: jspb.BinaryReader): RetryAutoExposeRequest;
}

export namespace RetryAutoExposeRequest {
  export type AsObject = {
    port: number,
  }
}

export class RetryAutoExposeResponse extends jspb.Message {
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): RetryAutoExposeResponse.AsObject;
  static toObject(includeInstance: boolean, msg: RetryAutoExposeResponse): RetryAutoExposeResponse.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: RetryAutoExposeResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): RetryAutoExposeResponse;
  static deserializeBinaryFromReader(message: RetryAutoExposeResponse, reader: jspb.BinaryReader): RetryAutoExposeResponse;
}

export namespace RetryAutoExposeResponse {
  export type AsObject = {
  }
}

export interface TunnelVisiblityMap {
  NONE: 0;
  HOST: 1;
  NETWORK: 2;
}

export const TunnelVisiblity: TunnelVisiblityMap;

