// package: supervisor
// file: token.proto

import * as token_pb from "./token_pb";
import {grpc} from "@improbable-eng/grpc-web";

type TokenServiceGetToken = {
  readonly methodName: string;
  readonly service: typeof TokenService;
  readonly requestStream: false;
  readonly responseStream: false;
  readonly requestType: typeof token_pb.GetTokenRequest;
  readonly responseType: typeof token_pb.GetTokenResponse;
};

type TokenServiceSetToken = {
  readonly methodName: string;
  readonly service: typeof TokenService;
  readonly requestStream: false;
  readonly responseStream: false;
  readonly requestType: typeof token_pb.SetTokenRequest;
  readonly responseType: typeof token_pb.SetTokenResponse;
};

type TokenServiceClearToken = {
  readonly methodName: string;
  readonly service: typeof TokenService;
  readonly requestStream: false;
  readonly responseStream: false;
  readonly requestType: typeof token_pb.ClearTokenRequest;
  readonly responseType: typeof token_pb.ClearTokenResponse;
};

type TokenServiceProvideToken = {
  readonly methodName: string;
  readonly service: typeof TokenService;
  readonly requestStream: true;
  readonly responseStream: true;
  readonly requestType: typeof token_pb.ProvideTokenRequest;
  readonly responseType: typeof token_pb.ProvideTokenResponse;
};

export class TokenService {
  static readonly serviceName: string;
  static readonly GetToken: TokenServiceGetToken;
  static readonly SetToken: TokenServiceSetToken;
  static readonly ClearToken: TokenServiceClearToken;
  static readonly ProvideToken: TokenServiceProvideToken;
}

export type ServiceError = { message: string, code: number; metadata: grpc.Metadata }
export type Status = { details: string, code: number; metadata: grpc.Metadata }

interface UnaryResponse {
  cancel(): void;
}
interface ResponseStream<T> {
  cancel(): void;
  on(type: 'data', handler: (message: T) => void): ResponseStream<T>;
  on(type: 'end', handler: (status?: Status) => void): ResponseStream<T>;
  on(type: 'status', handler: (status: Status) => void): ResponseStream<T>;
}
interface RequestStream<T> {
  write(message: T): RequestStream<T>;
  end(): void;
  cancel(): void;
  on(type: 'end', handler: (status?: Status) => void): RequestStream<T>;
  on(type: 'status', handler: (status: Status) => void): RequestStream<T>;
}
interface BidirectionalStream<ReqT, ResT> {
  write(message: ReqT): BidirectionalStream<ReqT, ResT>;
  end(): void;
  cancel(): void;
  on(type: 'data', handler: (message: ResT) => void): BidirectionalStream<ReqT, ResT>;
  on(type: 'end', handler: (status?: Status) => void): BidirectionalStream<ReqT, ResT>;
  on(type: 'status', handler: (status: Status) => void): BidirectionalStream<ReqT, ResT>;
}

export class TokenServiceClient {
  readonly serviceHost: string;

  constructor(serviceHost: string, options?: grpc.RpcOptions);
  getToken(
    requestMessage: token_pb.GetTokenRequest,
    metadata: grpc.Metadata,
    callback: (error: ServiceError|null, responseMessage: token_pb.GetTokenResponse|null) => void
  ): UnaryResponse;
  getToken(
    requestMessage: token_pb.GetTokenRequest,
    callback: (error: ServiceError|null, responseMessage: token_pb.GetTokenResponse|null) => void
  ): UnaryResponse;
  setToken(
    requestMessage: token_pb.SetTokenRequest,
    metadata: grpc.Metadata,
    callback: (error: ServiceError|null, responseMessage: token_pb.SetTokenResponse|null) => void
  ): UnaryResponse;
  setToken(
    requestMessage: token_pb.SetTokenRequest,
    callback: (error: ServiceError|null, responseMessage: token_pb.SetTokenResponse|null) => void
  ): UnaryResponse;
  clearToken(
    requestMessage: token_pb.ClearTokenRequest,
    metadata: grpc.Metadata,
    callback: (error: ServiceError|null, responseMessage: token_pb.ClearTokenResponse|null) => void
  ): UnaryResponse;
  clearToken(
    requestMessage: token_pb.ClearTokenRequest,
    callback: (error: ServiceError|null, responseMessage: token_pb.ClearTokenResponse|null) => void
  ): UnaryResponse;
  provideToken(metadata?: grpc.Metadata): BidirectionalStream<token_pb.ProvideTokenRequest, token_pb.ProvideTokenResponse>;
}

